import java.util.*;

public class Ticker extends Observable implements Runnable, Observer {

    private int period;
    private Thread t;
    private boolean terminate = false;

    public Ticker(int aPeriod) {
	period = aPeriod;
	t = new Thread(this);
    }

    public void start() {
	t.start();
    }

    public synchronized void run() {
	long next = System.currentTimeMillis() + period;
	while(!terminate) {
	    try {
		wait(Math.max(next - System.currentTimeMillis(),1));
	    } catch (InterruptedException e) {}
	    //
	    // Both setChanged and notifyObservers are needed
	    // to actually notify all the observers.
	    //
	    if (!terminate) {
		setChanged();
		notifyObservers(EventType.TICK);
	    }
	    next += period;
	}
	System.out.println("Ticker terminates");
    }

    public void update(Observable o, Object arg) {
	if (arg instanceof EventType) {
	    EventType anEvent = (EventType)arg;
	    if (anEvent == EventType.TIMEOUT)
		terminate = true;
	}
    }
}
